/**
 * Extends the browser with jolicloud functions
 */

window.addEventListener( "load", function( e )
{
	//Load the jolicloud-system extension
	
	//Browser content
	var appContent = document.getElementById( "appcontent" ); //Firefox
	if(! appContent )
		appContent = document.getElementById( "browser_content" ); //Prism
		
	//Listens to all DOM contents loaded
	appContent.addEventListener( "DOMContentLoaded", function( event )
	{
		//Add the basic jolicloud objects to the web page
		if( event.originalTarget.nodeName == '#document' )
		{
			Jolicloud.deleteSession( event.originalTarget.defaultView );
			var session = Jolicloud.getSession( event.originalTarget.defaultView );
			if( session.isAuthorizedWebpage() )
			{
				//We check if the wepbage is authorized before injecting
				//this is NOT for security but for performance
				session.injectCode( JolicloudUtils.loadWebpageJSFile( 'JolicloudUtils' ) );
				session.injectCode( JolicloudUtils.loadWebpageJSFile( 'JolicloudCommunicator' ) );
				session.injectCode( JolicloudUtils.loadWebpageJSFile( 'Jolicloud' ) );
				//Launches the onJolicloudLoaded function, if any
				session.injectCode( ''
					+ "\n" + 	'if( typeof window.onJolicloudLoaded == "function" )'
					+ "\n" + 	'	window.onJolicloudLoaded()' );
			}
		}
	}, false );
	//Will listen to Jolicloud events triggered by all webpages
	new JolicloudCommunicator();
	
	//Change the default user agent to Jolicloud
	var preferences = Components.classes['@mozilla.org/preferences-service;1']
         .getService(Components.interfaces.nsIPrefService)
         .getDefaultBranch('general.useragent.');
	preferences.QueryInterface(Components.interfaces.nsIPrefBranch);
	preferences.setCharPref('vendor', 'Jolicloud');
	preferences.setCharPref('vendorComment', 'robby');
	preferences.setCharPref('vendorSub', 'alpha');
}, false );
