/**
 * Jolicloud account management
 */
var JolicloudAccount = {
	/**
	 * Get the computer UUID
	 */
	getComputerUUID: function(callback)
	{
		Jolicloud.getCommunicator().call("JolicloudAccount", "getComputerUUID", callback);
	},
	
	/**
	 * Get the currently saved Jolicloud token
	 */
	getJolicloudToken: function(callback)
	{
		Jolicloud.getCommunicator().call("JolicloudAccount", "getJolicloudToken", callback);
	},
	
	/**
	 * Set the currently saved Jolicloud token
	 */
	setJolicloudToken: function(token_key, token_secret, callback)
	{
		Jolicloud.getCommunicator().call("JolicloudAccount", "setJolicloudToken", callback, token_key, token_secret);
	},
	
	/**
	 * Refresh the Jolicloud token
	 */
	refreshJolicloudToken: function(callback)
	{
		Jolicloud.getCommunicator().call("JolicloudAccount", "refreshJolicloudToken", callback);
	},
	
	/**
	 * Get the actions count
	 */
	getActionsCount: function(callback)
	{
		Jolicloud.getCommunicator().call("JolicloudAccount", "getActionsCount", callback);
	},
	
	/**
	 * Set the actions until now as read
	 */
	setActionsRead: function(readTime, callback)
	{
		Jolicloud.getCommunicator().call("JolicloudAccount", "setActionsRead", callback, readTime.getTime());
	},
	
	/**
	 * Listen to the count of actions of the user
	 * @param {Object} callback
	 * @param {Object} active If true, start listening, else stop listening (for this callback)
	 */
	listenToActionsCount: function(active, callback)
	{
		Jolicloud.getCommunicator().listen("JolicloudAccount", "listenToActionsCount", callback, active);
	}
}

window.JolicloudAccount = JolicloudAccount;
