/**
 * Utils for the extension
 */

var JolicloudUtils =
{	
	/**
	 * Loads a JS file for the webpage
	 */
	loadWebpageJSFile: function( className )
	{
		className = className.replace( /Jolicloud(.+)/, '$1' );	//supports JolicloudSystem or System
		return this.readExtFile( "chrome/content/jolicloud-webpage/" + className + ".js" );
	},
	
	/**
	 * Reads a file from the extension
	 */
	readExtFile: function( path )
	{		
		var extManager = Components.classes["@mozilla.org/extensions/manager;1"].
			 getService( Components.interfaces.nsIExtensionManager );
		var file = extManager.getInstallLocation( Jolicloud.id ).getItemFile( Jolicloud.id, path );
		return this.readFile( file );
	},
	
	/**
	 * Reads a local file
	 */
	readFile: function( file )
	{
		try
		{
			var data     = new String();
			var fiStream = Components.classes['@mozilla.org/network/file-input-stream;1']
				.createInstance( Components.interfaces.nsIFileInputStream );
			var siStream = Components.classes['@mozilla.org/scriptableinputstream;1']
				.createInstance( Components.interfaces.nsIScriptableInputStream );
			fiStream.init( file, 1, 0, false );
			siStream.init( fiStream );
			data += siStream.read( -1 );
			siStream.close();
			fiStream.close();
			return data;
		} 
		catch( e )
		{
			return false;
		}
	},

	/**
	 * Converts an object to JSON
	 */
	toJson: function( obj )
	{
		if( typeof JSON == "undefined" || typeof JSON.stringify != "function" )
		{
			var nativeJSON = Components.classes["@mozilla.org/dom/json;1"]
				.createInstance(Components.interfaces.nsIJSON);
			string = nativeJSON.encode( [obj] )
			return string.substr( 1, string.length - 2 );
		}
		else
		{
			return JSON.stringify( obj );
		}
	},
	
	/**
	 * Parse JSON securely (without eval)
	 */
	fromJson: function ( json )
	{
		if( typeof JSON == "undefined" || typeof JSON.parse != "function" )
		{
			var nativeJSON = Components.classes["@mozilla.org/dom/json;1"]
				.createInstance(Components.interfaces.nsIJSON);
			//Quick fix: otherwise 'false' doesn't work :/
			return nativeJSON.decode( '[' + json + ']' )[0];
		}
		else
		{
			return JSON.parse( json );
		}
	}
}

